$Include "Tradingview_to_MT4_csv_converterTiny.Inc" ' added by RQPC (add only comments above me)
''pre cmd FBVERSION=017 FBLANG=deprecated run enc noopt exe con NoDone icon QChartist.ico kill includes\cppincludes2.cpp
''pre end

' TradingView to MT4 csv file converter programmed by Julien Moog in 2021-09-06
' In Tradingview you have to put the volume indicator
' You need a Pro+ plan in order to export charts
' Then click "Export chart data", Time format: UNIX timestamp then click Export
' Now you can use this utility to convert the Tradingview exported csv files
' Enjoy and happy trading

'Compiler Directrapidqives
$APPTYPE console  'GUI
$OPTIMIZE on
$TYPECHECK on

Declare Function timeGetTime Lib "winmm.dll" Alias "timeGetTime" () As long
DECLARE FUNCTION isLeapYear(Year AS LONG) AS LONG
DECLARE FUNCTION DateSerial(Y AS LONG , M AS LONG , D AS LONG) AS LONG
DECLARE FUNCTION DateFromSerial(DateSerial AS double , ByRef Year AS LONG , ByRef Month AS LONG , ByRef Day AS LONG, ByRef Hour AS LONG, ByRef Minute AS LONG, ByRef Second AS double) AS long
declare function strtomonth(str as string) as string

defdbl myvar
myvar=timegettime()
defstr myvarstr=Format$("%12.0f", myvar)

declare sub convertfile

create form as qform
create selectfile as qbutton
width=200
caption="Tradingview to MT4 csv"
onclick=convertfile
end create
end create

sub convertfile

dim opendialog as qopendialog
opendialog.filter="Csv files|*.csv"
opendialog.filterindex=1

IF OpenDialog.Execute THEN

dim file as qfilestream
dim line() as string
defint i=0
file.open(opendialog.filename,0)
while not file.eof
line(i)=file.readline
i++
wend
file.close

'defstr myunixtimestr=myedit.text 'Format$("%12.0f", unixtimeratio)
'cpptmpfuncreturn=varptr$(unix_time_to_date(varptr(myunixtimestr)))
'defstr year,month,day,hour,minute
'year=mid$(cpptmpfuncreturn,0,4)
'month=mid$(cpptmpfuncreturn,6,2)
'day=mid$(cpptmpfuncreturn,9,2)
'hour=mid$(cpptmpfuncreturn,12,2)
'minute=mid$(cpptmpfuncreturn,15,2)
'defstr graphdateoncur =year + "-" + month + "-" + day+" "+hour+":"+minute
'print graphdateoncur

defint converted_file_loc
defstr converted_file
defstr converted_file_tf
converted_file_loc=INSTR(opendialog.filename , ".csv")
converted_file=mid$(opendialog.filename,1,converted_file_loc-1)
converted_file_loc=INSTR(opendialog.filename , ",")
converted_file=mid$(opendialog.filename,1,converted_file_loc-1)
converted_file_tf=mid$(opendialog.filename,converted_file_loc+2,len(opendialog.filename))
converted_file_loc=INSTR(converted_file_tf , ".")
converted_file_tf=mid$(converted_file_tf,1,converted_file_loc-1)

defstr convtf
convtf=converted_file_tf

if converted_file_tf="1D" then convtf="1440"
if converted_file_tf="1W" then convtf="10080"
if converted_file_tf="1M" then convtf="43200"

file.open(converted_file+convtf+".csv",65535)
defint j
dim modifline as string
defint comaplace
defstr timestmp,opena,higha,lowa,closea,volumea
defstr year,month,day,hour,minute
defstr graphdateoncur
defstr cpptmpfuncreturn,myunixtimestr

for j=1 to i-1
'modifline=mid$(line(j),1,4)+"/"+mid$(line(j),6,2)+"/"+mid$(line(j),9,len(line(j)))
comaplace = INSTR(line(j) , ",")
timestmp=mid$(line(j),1,comaplace-1)
line(j) = MID$(line(j) , comaplace + 1,len(line(j)))
comaplace = INSTR(line(j) , ",")
opena=mid$(line(j),1,comaplace-1)
line(j) = MID$(line(j) , comaplace + 1,len(line(j)))
comaplace = INSTR(line(j) , ",")
higha=mid$(line(j),1,comaplace-1)
line(j) = MID$(line(j) , comaplace + 1,len(line(j)))
comaplace = INSTR(line(j) , ",")
lowa=mid$(line(j),1,comaplace-1)
line(j) = MID$(line(j) , comaplace + 1,len(line(j)))
comaplace = INSTR(line(j) , ",")
closea=mid$(line(j),1,comaplace-1)
line(j) = MID$(line(j) , comaplace + 1,len(line(j)))
comaplace = INSTR(line(j) , ",")
volumea=mid$(line(j),1,comaplace-1)

'myunixtimestr=Format$("%12.0f", timestmp)
cpptmpfuncreturn=varptr$(unix_time_to_date(varptr(timestmp)))
year=mid$(cpptmpfuncreturn,0,4)
month=mid$(cpptmpfuncreturn,6,2)
day=mid$(cpptmpfuncreturn,9,2)
hour=mid$(cpptmpfuncreturn,12,2)
minute=mid$(cpptmpfuncreturn,15,2)
graphdateoncur =year + "." + month + "." + day+","+hour+":"+minute

modifline=graphdateoncur+","+opena+","+higha+","+lowa+","+closea+","+volumea
file.writeline(modifline)
next j
file.close

showmessage "done"

end if

end sub

form.showmodal

FUNCTION isLeapYear(Year AS LONG) AS LONG
    Result = 0
    IF ((Year MOD 4) = 0) AND ((Year MOD 100) > 0) OR ((Year MOD 400) = 0) THEN Result = 1
END FUNCTION    

FUNCTION DateSerial(Y AS LONG , M AS LONG , D AS LONG) AS LONG
    'declare
    DEFLNG daysCount , dayOfMonth , Year , Month

    'initialize
    daysCount = D

    'process
    IF M > 1 THEN
        Month = M
        dayOfMonth = &H3DFF7F9F
        IF Month > 2 AND isLeapYear(Y) THEN dayOfMonth = (dayOfMonth + 32)
        DO
            daysCount = daysCount + (dayOfMonth AND 31)
            IF Month = 2 THEN EXIT DO
            Month = Month - 1
            dayOfMonth = dayOfMonth \ 32
            IF dayOfMonth = 0 THEN dayOfMonth = &H3FEFFBFF
        LOOP
    END IF

    'exit
    Year = (Y - 1)
    Result = daysCount + (CLNG(Year) * 365) + (Year \ 4) - (Year \ 100) + (Year \ 400)
END FUNCTION


FUNCTION DateFromSerial(DateSerial AS double , ByRef Year AS LONG , ByRef Month AS LONG , ByRef Day AS LONG, ByRef Hour AS LONG,ByRef Minute AS LONG,ByRef Second AS double) AS long
    'declare
    
    deflng hoursrest=0
    defstr DateSerialstr=Format$("%12.0f", DateSerial)

    'defdbl secondsrest=DateSerial mod 86400

    defstr amodstr="86400"

    defdbl secondsrest=val(varptr$(rqmod(varptr(DateSerialstr),varptr(amodstr))))

    Second=secondsrest

    defdbl secondsrest2=secondsrest

    secondsrest=secondsrest2 mod 60
 
    Second=secondsrest  

    deflng minutesrest=secondsrest2 / 60

    deflng minutesrest2=minutesrest

    minutesrest=minutesrest2 mod 3600

    Minute=minutesrest      

    if minutesrest mod 60=0 then 
    minutesrest2=minutesrest
    minutesrest=0
    end if           

    Minute=minutesrest mod 60     

    hoursrest=minutesrest2 / 60

    Hour=hoursrest       
    
    DateSerial=DateSerial/24/60/60  
    'showmessage(str$(DateSerial))  
    DEFLNG daysCount , dayOfMonth , dayTotal
    DateSerial=DateSerial+719163
    'showmessage(str$(DateSerial))
    
    'showmessage(str$(dayTotal))
    'showmessage(str$(dayOfMonth))
    'showmessage(str$(daysCount))
    'showmessage(str$(DateSerial))

    'initialize
    Year = 1
    Month = 1
    daysCount = DateSerial - 1
    
    'showmessage(str$(daysCount))

    'pre-process
    IF daysCount > 146096 THEN
        Year = Year + (daysCount \ 146097) * 400
        daysCount = (daysCount MOD 146097)
    END IF
    IF daysCount > 36523 THEN
        dayTotal = (daysCount \ 36524)
        'showmessage(str$(dayTotal))
        IF dayTotal < 4 THEN
            Year = Year + (dayTotal * 100)
            daysCount = (daysCount MOD 36524)
        ELSE
            Year = Year + 300
            daysCount = 36524
        END IF
    END IF
    IF daysCount > 1460 THEN
        Year = Year + (daysCount \ 1461) * 4
        daysCount = (daysCount MOD 1461)
    END IF
    IF daysCount > 364 THEN
        dayTotal = (daysCount \ 365)
        'showmessage(str$(dayTotal))
        IF dayTotal < 4 THEN
            Year = Year + dayTotal
            daysCount = (daysCount MOD 365)
        ELSE
            Year = Year + 3
            daysCount = 365
        END IF
    END IF

    'process
    Day = daysCount + 1
    dayOfMonth = &H3DFF7F9F
    IF Day > 58 AND isLeapYear(Year) THEN dayOfMonth = (dayOfMonth + 32)
    
    'showmessage(str$(dayOfMonth))
    'showmessage(str$(dayTotal))
    'showmessage(str$(Day))
    'showmessage(str$(Month))
    
    DO
        dayTotal = (dayOfMonth AND 31)
        IF dayTotal >= Day THEN EXIT DO
        Day = Day - dayTotal
        Month = Month + 1
        dayOfMonth = (dayOfMonth \ 32)
        IF dayOfMonth = 0 THEN dayOfMonth = &H3FEFFBFF
    LOOP

    'exit
    Result = (DateSerial MOD 7)
END FUNCTION    

function strtomonth(str as string) as string
select case str
case "Jan": result="01"
case "Feb": result="02"
case "Mar": result="03"
case "Apr": result="04"
case "May": result="05"
case "Jun": result="06"
case "Jul": result="07"
case "Aug": result="08"
case "Sep": result="09"
case "Oct": result="10"
case "Nov": result="11"
case "Dec": result="12"
end select
end function
